diff --git a/doc/guides/nics/features/cnxk.ini b/doc/guides/nics/features/cnxk.ini
index 40952a9..192c15a 100644
--- a/doc/guides/nics/features/cnxk.ini
+++ b/doc/guides/nics/features/cnxk.ini
@@ -34,6 +34,7 @@ Inner L4 checksum    = Y
 Packet type parsing  = Y
 Basic stats          = Y
 Stats per queue      = Y
+Extended stats       = Y
 Module EEPROM dump   = Y
 Linux                = Y
 ARMv8                = Y
diff --git a/doc/guides/nics/features/cnxk_vec.ini b/doc/guides/nics/features/cnxk_vec.ini
index 32035bb..e990480 100644
--- a/doc/guides/nics/features/cnxk_vec.ini
+++ b/doc/guides/nics/features/cnxk_vec.ini
@@ -32,6 +32,7 @@ Inner L4 checksum    = Y
 Packet type parsing  = Y
 Basic stats          = Y
 Stats per queue      = Y
+Extended stats       = Y
 Module EEPROM dump   = Y
 Linux                = Y
 ARMv8                = Y
diff --git a/doc/guides/nics/features/cnxk_vf.ini b/doc/guides/nics/features/cnxk_vf.ini
index 8060a68..3a4417c 100644
--- a/doc/guides/nics/features/cnxk_vf.ini
+++ b/doc/guides/nics/features/cnxk_vf.ini
@@ -29,6 +29,7 @@ Inner L4 checksum    = Y
 Packet type parsing  = Y
 Basic stats          = Y
 Stats per queue      = Y
+Extended stats       = Y
 Module EEPROM dump   = Y
 Linux                = Y
 ARMv8                = Y
diff --git a/drivers/net/cnxk/cnxk_ethdev.c b/drivers/net/cnxk/cnxk_ethdev.c
index ecc7f13..27b92f9 100644
--- a/drivers/net/cnxk/cnxk_ethdev.c
+++ b/drivers/net/cnxk/cnxk_ethdev.c
@@ -1187,6 +1187,11 @@ struct eth_dev_ops cnxk_eth_dev_ops = {
 	.queue_stats_mapping_set = cnxk_nix_queue_stats_mapping,
 	.stats_get = cnxk_nix_stats_get,
 	.stats_reset = cnxk_nix_stats_reset,
+	.xstats_get = cnxk_nix_xstats_get,
+	.xstats_get_names = cnxk_nix_xstats_get_names,
+	.xstats_reset = cnxk_nix_xstats_reset,
+	.xstats_get_by_id = cnxk_nix_xstats_get_by_id,
+	.xstats_get_names_by_id = cnxk_nix_xstats_get_names_by_id,
 };
 
 static int
diff --git a/drivers/net/cnxk/cnxk_ethdev.h b/drivers/net/cnxk/cnxk_ethdev.h
index 860cfe1..5a0dc13 100644
--- a/drivers/net/cnxk/cnxk_ethdev.h
+++ b/drivers/net/cnxk/cnxk_ethdev.h
@@ -294,6 +294,17 @@ int cnxk_nix_queue_stats_mapping(struct rte_eth_dev *dev, uint16_t queue_id,
 				 uint8_t stat_idx, uint8_t is_rx);
 int cnxk_nix_stats_reset(struct rte_eth_dev *dev);
 int cnxk_nix_stats_get(struct rte_eth_dev *dev, struct rte_eth_stats *stats);
+int cnxk_nix_xstats_get(struct rte_eth_dev *eth_dev,
+			struct rte_eth_xstat *xstats, unsigned int n);
+int cnxk_nix_xstats_get_names(struct rte_eth_dev *eth_dev,
+			      struct rte_eth_xstat_name *xstats_names,
+			      unsigned int limit);
+int cnxk_nix_xstats_get_names_by_id(struct rte_eth_dev *eth_dev,
+				    struct rte_eth_xstat_name *xstats_names,
+				    const uint64_t *ids, unsigned int limit);
+int cnxk_nix_xstats_get_by_id(struct rte_eth_dev *eth_dev, const uint64_t *ids,
+			      uint64_t *values, unsigned int n);
+int cnxk_nix_xstats_reset(struct rte_eth_dev *eth_dev);
 
 /* Lookup configuration */
 const uint32_t *cnxk_nix_supported_ptypes_get(struct rte_eth_dev *eth_dev);
diff --git a/drivers/net/cnxk/cnxk_stats.c b/drivers/net/cnxk/cnxk_stats.c
index 24bff0b..19bab21 100644
--- a/drivers/net/cnxk/cnxk_stats.c
+++ b/drivers/net/cnxk/cnxk_stats.c
@@ -4,6 +4,9 @@
 
 #include "cnxk_ethdev.h"
 
+#define CNXK_NB_RXQ_STATS 5
+#define CNXK_NB_TXQ_STATS 4
+
 int
 cnxk_nix_stats_get(struct rte_eth_dev *eth_dev, struct rte_eth_stats *stats)
 {
@@ -83,3 +86,235 @@ cnxk_nix_queue_stats_mapping(struct rte_eth_dev *eth_dev, uint16_t queue_id,
 
 	return 0;
 }
+
+int
+cnxk_nix_xstats_get(struct rte_eth_dev *eth_dev, struct rte_eth_xstat *xstats,
+		    unsigned int n)
+{
+	struct cnxk_eth_dev *dev = cnxk_eth_pmd_priv(eth_dev);
+	struct roc_nix_xstat roc_xstats[n];
+	struct roc_nix *nix = &dev->nix;
+	int roc_size, q, idx = 0, size;
+
+	roc_size = roc_nix_xstats_get(nix, roc_xstats, n);
+
+	if (roc_size < 0)
+		return roc_size;
+
+	/* Per Queue statistics also returned as part of xstats */
+	size = roc_size + (dev->nb_rxq * CNXK_NB_RXQ_STATS) +
+	       (dev->nb_txq * CNXK_NB_TXQ_STATS);
+
+	/* If requested array do not have space then return with count */
+	if (size > (int)n || xstats == NULL)
+		return size;
+
+	for (idx = 0; idx < roc_size; idx++) {
+		xstats[idx].id = roc_xstats[idx].id;
+		xstats[idx].value = roc_xstats[idx].value;
+	}
+	for (q = 0; q < dev->nb_rxq; q++) {
+		struct roc_nix_stats_queue qstats;
+		int rc;
+
+		rc = roc_nix_stats_queue_get(nix, q, 1, &qstats);
+		if (rc)
+			return rc;
+
+		xstats[idx].id = idx;
+		xstats[idx].value = qstats.rx_pkts;
+		idx++;
+		xstats[idx].id = idx;
+		xstats[idx].value = qstats.rx_octs;
+		idx++;
+		xstats[idx].id = idx;
+		xstats[idx].value = qstats.rx_drop_pkts;
+		idx++;
+		xstats[idx].id = idx;
+		xstats[idx].value = qstats.rx_drop_octs;
+		idx++;
+		xstats[idx].id = idx;
+		xstats[idx].value = qstats.rx_error_pkts;
+		idx++;
+	}
+	for (q = 0; q < dev->nb_txq; q++) {
+		struct roc_nix_stats_queue qstats;
+		int rc;
+
+		rc = roc_nix_stats_queue_get(nix, q, 0, &qstats);
+		if (rc)
+			return rc;
+
+		xstats[idx].id = idx;
+		xstats[idx].value = qstats.tx_pkts;
+		idx++;
+		xstats[idx].id = idx;
+		xstats[idx].value = qstats.tx_octs;
+		idx++;
+		xstats[idx].id = idx;
+		xstats[idx].value = qstats.tx_drop_pkts;
+		idx++;
+		xstats[idx].id = idx;
+		xstats[idx].value = qstats.tx_drop_octs;
+		idx++;
+	}
+
+	return size;
+}
+
+int
+cnxk_nix_xstats_get_names(struct rte_eth_dev *eth_dev,
+			  struct rte_eth_xstat_name *xstats_names,
+			  unsigned int limit)
+{
+	struct cnxk_eth_dev *dev = cnxk_eth_pmd_priv(eth_dev);
+	struct roc_nix_xstat_name roc_xstats_name[limit];
+	struct roc_nix *nix = &dev->nix;
+	int roc_size, size, i, q;
+
+	roc_size = roc_nix_num_xstats_get(nix);
+	/* Per Queue statistics also returned as part of xstats */
+	size = roc_size + (dev->nb_rxq * CNXK_NB_RXQ_STATS) +
+	       (dev->nb_txq * CNXK_NB_TXQ_STATS);
+
+	if (xstats_names == NULL)
+		return size;
+
+	if ((int)limit < size && xstats_names != NULL)
+		return size;
+
+	roc_size = roc_nix_xstats_names_get(nix, roc_xstats_name, limit);
+
+	for (i = 0; i < roc_size; i++)
+		rte_strscpy(xstats_names[i].name, roc_xstats_name[i].name,
+			    sizeof(xstats_names[i].name));
+
+	for (q = 0; q < dev->nb_rxq; q++) {
+		snprintf(xstats_names[i].name, sizeof(xstats_names[i].name),
+			 "rxq_%d_pkts", q);
+		i++;
+		snprintf(xstats_names[i].name, sizeof(xstats_names[i].name),
+			 "rxq_%d_octs", q);
+		i++;
+		snprintf(xstats_names[i].name, sizeof(xstats_names[i].name),
+			 "rxq_%d_drop_pkts", q);
+		i++;
+		snprintf(xstats_names[i].name, sizeof(xstats_names[i].name),
+			 "rxq_%d_drop_octs", q);
+		i++;
+		snprintf(xstats_names[i].name, sizeof(xstats_names[i].name),
+			 "rxq_%d_err_pkts", q);
+		i++;
+	}
+
+	for (q = 0; q < dev->nb_txq; q++) {
+		snprintf(xstats_names[i].name, sizeof(xstats_names[i].name),
+			 "txq_%d_pkts", q);
+		i++;
+		snprintf(xstats_names[i].name, sizeof(xstats_names[i].name),
+			 "txq_%d_octs", q);
+		i++;
+		snprintf(xstats_names[i].name, sizeof(xstats_names[i].name),
+			 "txq_%d_drop_pkts", q);
+		i++;
+		snprintf(xstats_names[i].name, sizeof(xstats_names[i].name),
+			 "txq_%d_drop_octs", q);
+		i++;
+	}
+
+	return size;
+}
+
+int
+cnxk_nix_xstats_get_names_by_id(struct rte_eth_dev *eth_dev,
+				struct rte_eth_xstat_name *xstats_names,
+				const uint64_t *ids, unsigned int limit)
+{
+	struct cnxk_eth_dev *dev = cnxk_eth_pmd_priv(eth_dev);
+	uint32_t nix_cnt = roc_nix_num_xstats_get(&dev->nix);
+	uint32_t stat_cnt = nix_cnt + (dev->nb_rxq * CNXK_NB_RXQ_STATS) +
+			    (dev->nb_txq * CNXK_NB_TXQ_STATS);
+	struct rte_eth_xstat_name xnames[stat_cnt];
+	uint32_t i;
+
+	if (limit < stat_cnt && ids == NULL)
+		return stat_cnt;
+
+	if (limit > stat_cnt)
+		return -EINVAL;
+
+	if (xstats_names == NULL)
+		return -ENOMEM;
+
+	cnxk_nix_xstats_get_names(eth_dev, xnames, stat_cnt);
+
+	for (i = 0; i < limit; i++) {
+		if (ids[i] >= stat_cnt)
+			return -EINVAL;
+
+		rte_strscpy(xstats_names[i].name, xnames[ids[i]].name,
+			    sizeof(xstats_names[i].name));
+	}
+
+	return limit;
+}
+
+int
+cnxk_nix_xstats_get_by_id(struct rte_eth_dev *eth_dev, const uint64_t *ids,
+			  uint64_t *values, unsigned int n)
+{
+	struct cnxk_eth_dev *dev = cnxk_eth_pmd_priv(eth_dev);
+	uint32_t nix_cnt = roc_nix_num_xstats_get(&dev->nix);
+	uint32_t stat_cnt = nix_cnt + (dev->nb_rxq * CNXK_NB_RXQ_STATS) +
+			    (dev->nb_txq * CNXK_NB_TXQ_STATS);
+	struct rte_eth_xstat xstats[stat_cnt];
+	uint32_t i;
+
+	if (n < stat_cnt && ids == NULL)
+		return stat_cnt;
+
+	if (n > stat_cnt)
+		return -EINVAL;
+
+	if (values == NULL)
+		return -ENOMEM;
+
+	cnxk_nix_xstats_get(eth_dev, xstats, stat_cnt);
+
+	for (i = 0; i < n; i++) {
+		if (ids[i] >= stat_cnt)
+			return -EINVAL;
+		values[i] = xstats[ids[i]].value;
+	}
+
+	return n;
+}
+
+int
+cnxk_nix_xstats_reset(struct rte_eth_dev *eth_dev)
+{
+	struct cnxk_eth_dev *dev = cnxk_eth_pmd_priv(eth_dev);
+	struct roc_nix *nix = &dev->nix;
+	int rc = 0, i;
+
+	rc = roc_nix_stats_reset(nix);
+	if (rc)
+		goto exit;
+
+	/* Reset Rx Queues */
+	for (i = 0; i < dev->nb_rxq; i++) {
+		rc = roc_nix_stats_queue_reset(nix, i, 1);
+		if (rc)
+			goto exit;
+	}
+
+	/* Reset Tx Queues */
+	for (i = 0; i < dev->nb_txq; i++) {
+		rc = roc_nix_stats_queue_reset(nix, i, 0);
+		if (rc)
+			goto exit;
+	}
+
+exit:
+	return rc;
+}